import peasy.*;
import controlP5.*;
PeasyCam cam;
ControlP5 cp5;
CheckBox checkbox;


Table table;
Table table1;
Table table2;
int numRows, numColumns;
int cols1, rows1;
int Tall =(-20)*49;

float angle;
int r = 200;
int size;
//float x,y,z;
int gap = 49;

////////////////////////
//floating waves
float theta = 0.0;

//terrain
float[][] terrain;

int cols, rows;
int scl = 10;

int pop_min = 1000000000;
int pop_max = -1;
float GDP_min = 1000000000;
float GDP_max = -1;

/////////////////////////

ArrayList<country> countries = new ArrayList<country>();
ArrayList<country> countriesterrain = new ArrayList<country>();


color[] colormap = {#A8F98F, #B0F384, #B8EC7A, #C0E670, #C7DF68, #CED961, #D4D25B, #D9CB57, #DEC453, #E3BD51, #E6B651, #E9AF51, #ECA852, #EDA155, #EE9B57, #EE945A, #ED8E5E, #EB8862};

String[] class_names = {"Australia", "Canada", "China", "France", "Germany", "Italy", "Japan", "NewZealand",
  "Russia", "Saudi Arabia", "Singapore", "South Africa", "Spain", "Sweden", "Switzerland", "United Arab Emirates",
  "United Kingdom", "United States"};
int[] class_year = {1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977, 1978, 1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987, 1988,
  1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
  2012, 2013, 2014, 2015, 2016, 2017, 2018};
// use linear regression to order the countries
void setup() {
  size(1920, 1080, P3D);
  cam = new PeasyCam(this, 1000);
  cam.setMinimumDistance(-20000);
  cam.setMaximumDistance(24000);
  cp5 = new ControlP5(this);
  smooth();

  //table read for waving dots
  table = loadTable("datafinal.csv");
  numColumns = table.getColumnCount();
  numRows = table.getRowCount();
  cols =  class_year.length;
  rows =  class_year.length;
  terrain = new float[cols][1000];

  for (int i = 1; i < numRows; i++) {
    String name = table.getString(i, 1);
    int year = table.getInt(i, 2);
    float CO2perGdp = table.getFloat(i, 4);
    float GDP = table.getFloat(i, 6);
    int population = table.getInt(i, 5);
    float energyperGdp = table.getFloat(i, 7);
    countries.add(new country(name, year, CO2perGdp, population, GDP, energyperGdp));
  }


  angle = 2*PI/(class_names.length);
  /////////////////////////////


  loadData(table, countriesterrain);
  terrain = formTerrain(countriesterrain);
}
void draw() {

  background(0);
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  drawInfo();
  cp5.draw();
  drawInfo();
  //gui();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);

  theta+=0.02;
  if (showwave) {
    for (int p =0; p<class_names.length; p++) {
      DrawDots(countries, class_names[p], r*sin(angle*p), r*cos(angle*p), colormap[p]);
    }
  }
  stroke(255);
  strokeWeight(1);
  noFill();
  pushMatrix();
  translate(-100, Tall/2+50, 120);
  box(r+300, Tall-100, r+350);
  popMatrix();
  //reference dots
  //stroke(20, 202, 20);
  //strokeWeight(20);
  //point(0, 0, 0);

  strokeWeight(5);

  Drawterrain(terrain, colormap);
}
